]> arthur.barton.de Git - backup-script.git/blobdiff - bin/backup-script
backup-script-wrapper: Return exit code of backup-script
[backup-script.git] / bin / backup-script
index 457a5e7be4a1bdbbc47702be179894da77ef0b03..0ac5fe242ad22abf5780b953e13027773a7a1524 100755 (executable)
@@ -26,11 +26,13 @@ declare -i count_ok_vanished=0
 destinations=""
 
 # Default settings, can be overwritten in backup-script.conf:
-conf_d="/etc/backup-script.d"
+[ -d "/usr/local/etc/backup-script.d" ] \
+       && conf_d="/usr/local/etc/backup-script.d" \
+       || conf_d="/etc/backup-script.d"
 pre_exec=""
 post_exec=""
 default_source_root="/"
-default_target=""
+default_target="/var/backups"
 default_user="root"
 default_ssh_args_add=""
 default_rsync_args_add=""
@@ -50,6 +52,9 @@ Usage() {
        echo
        echo "When no <system> is given, all defined systems are used."
        echo
+       echo "Configuration file is \"$conf\","
+       echo "using \"$conf_d\" as configuration directory."
+       echo
        exit 1
 }
 
@@ -72,6 +77,7 @@ GotSignal() {
        CleanUp
        echo -n "Aborted: "; date
        echo
+       sleep 3
        exit 9
 }
 
@@ -122,6 +128,9 @@ CreateSubvolume() {
          "btrfs")
                btrfs subvolume create "$volume"  >/dev/null || return 1
                ;;
+         "zfs")
+               zfs create "$(echo "$volume" | cut -c2-)" || return 1
+               ;;
          *)
                echo "CreateSubvolume: Incompatible FS type \"$fs\" on \"$dir\"!"
                return 9
@@ -135,6 +144,7 @@ CloneSubvolume() {
        local snapshot="$3"
        local dir
        local fs
+       local link_name
 
        dir=$(dirname "source")
        fs=$(GetFS "$source")
@@ -142,6 +152,13 @@ CloneSubvolume() {
          "btrfs")
                btrfs subvolume snapshot "$source" "$snapshot"  >/dev/null || return 1
                ;;
+         "zfs")
+               zfs snapshot "$snapshot" || return 1
+               link_name="$(echo "$snapshot" | cut -d@ -f2-)"
+               ln -s \
+                       "$volume/.zfs/snapshot/$link_name" \
+                       "$(dirname "$volume")/$link_name"
+               ;;
          *)
                echo "CloneSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
                return 9
@@ -159,6 +176,12 @@ RenameSubvolume() {
          "btrfs")
                mv "$source" "$target" || return 1
                ;;
+         "zfs")
+               zfs rename \
+                 "$(echo "$source" | cut -c2-)" \
+                 "$(echo "$target" | cut -c2-)" \
+                       || return 1
+               ;;
          *)
                echo "RenameSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
                return 9
@@ -169,12 +192,24 @@ RenameSubvolume() {
 DeleteSubvolume() {
        local volume="$1"
        local fs
+       local id
+       local snapshot
 
-       fs=$(GetFS "$source")
+       fs=$(GetFS "$volume")
        case "$fs" in
          "btrfs")
                btrfs subvolume delete "$volume" >/dev/null || return 1
                ;;
+         "zfs")
+               id="$(basename "$volume")"
+               if [ -h "$volume" ]; then
+                       snapshot="$(dirname "$volume")/current@$id"
+               else
+                       snapshot="$volume"
+               fi
+               zfs destroy -r "$(echo "$snapshot" | cut -c2-)" >/dev/null || return 1
+               [ -h "$volume" ] && rm "$volume"
+               ;;
          *)
                echo "DeleteSubvolume: Incompatible FS type \"$fs\" on \"$volume\"!"
                return 9
@@ -182,6 +217,62 @@ DeleteSubvolume() {
        return 0
 }
 
+Initialize_Last_SysTarget_Snapshot() {
+       sys_target="$1"
+       unset last
+       unset snapshot
+
+       fs=$(GetFS "$sys_target")
+       case "$fs" in
+         "btrfs")
+               # Search directory of last generation, if any
+               last=$(ls -1d "$sys_target"/[0-9]* 2>/dev/null | sort -r | head -n1)
+               if [ -n "$last" ]; then
+                       if [ ! -d "$last" ]; then
+                               echo "Last snapshot \"$last\" seems not to be a directory!? \"$system\" skipped!"
+                               echo
+                               return 1
+                       fi
+               fi
+               sys_target="$sys_target/$(date +%Y%m%d-%H%M%S)"
+               snapshot="$sys_target"
+               ;;
+         "zfs")
+               # On ZFS, the last generation is always named "current"
+               if [ -e "$sys_target/current" ]; then
+                       last="$sys_target/current"
+                       if [ "$(uname)" = "Linux" ]; then
+                               date=$(LC_ALL=C stat "$1" | grep "^Modify: " \
+                                | cut -d':' -f2- | cut -d. -f1)
+                       else
+                               date=$(LC_ALL=C stat -f "%Sc" "$1")
+                       fi
+                       date=$(echo "$date" | sed -e's/^ //g' -e 's/[-:]//g' -e 's/ /-/g')
+
+               else
+                       last=""
+                       date="$(date +%Y%m%d-%H%M%S)"
+               fi
+               snapshot="$(echo "$sys_target/current" | cut -c2-)@$date"
+               sys_target="$sys_target/current"
+               ;;
+         *)
+               echo "Initialize_Last_SysTarget_Snapshot: Incompatible FS type \"$fs\" on \"$sys_target\"!"
+               return 1
+       esac
+       return 0
+}
+
+# Search configuration file (last one is used as default!)
+for conf in \
+       "/usr/local/etc/backup-script.conf" \
+       "/etc/backup-script.conf" \
+       "${conf_d}/backup-script.conf" \
+       "/usr/local/etc/backup-script.conf" \
+; do
+       [ -r "$conf" ] && break
+done
+
 while [ $# -gt 0 ]; do
        case "$1" in
          "-n"|"--dry-run")
@@ -202,12 +293,13 @@ trap GotSignal SIGINT
 
 echo -n "Started: "; date
 
-for conf in "/etc/backup-script.conf" "${conf_d}/backup-script.conf"; do
-       if [ -r "$conf" ]; then
-               echo "Reading configuration: \"$conf\" ..."
-               source "$conf"
-       fi
-done
+# Read in configuration file
+if [ -r "$conf" ]; then
+       echo "Reading configuration: \"$conf\" ..."
+       source "$conf"
+else
+       echo "No configuration file found, using defaults."
+fi
 echo
 
 if [ $# -ge 1 ]; then
@@ -277,11 +369,54 @@ for f in $sys; do
        job_pre_exec="$default_job_pre_exec"
        job_post_exec="$default_job_post_exec"
 
+       # Compatibility with backup-pull(1) script: Save global values ...
+       pre_exec_saved="$pre_exec"
+       post_exec_saved="$post_exec"
+
+       # Compatibility with backup-pull(1) script: Set defaults
+       unset host
+       unset source
+       unset pre_exec
+       unset post_exec
+
        # Read in system configuration file
        source "$f"
 
+       # Compatibility with backup-pull(1) script: Fix up configuration
+       [ "$system" = "$fname" -a -n "$host" ] \
+               && system="$host"
+       [ "$source_root" = "$default_source_root" -a -n "$source" ] \
+               && source_root="$source"
+       [ -z "$job_pre_exec" -a -n "$pre_exec" ] \
+               && job_pre_exec="$pre_exec"
+       [ -z "$job_post_exec" -a -n "$post_exec" ] \
+               && job_post_exec="$post_exec"
+
+       # Compatibility with backup-pull(1) script: Restore global values ...
+       pre_exec="$pre_exec_saved"
+       post_exec="$post_exec_saved"
+
        # Validate configuration
-       [ "$system" = "localhost" -o "$system" = "127.0.0.1" ] && local=1
+       if [ "$system" = "localhost" -o "$system" = "127.0.0.1" ]; then
+               # Local system
+               local=1
+               compress=0
+       fi
+
+       # Make sure "source" ends with a slash ("/")
+       case "$source" in
+         "*/")
+               ;;
+         "*")
+               source="$source/"
+       esac
+
+       # Make sure "target" DOESN'T end with a slash ("/")
+       case "$target" in
+         "*/")
+               target=$( echo "$target" | sed -e 's/\/$//g' )
+               ;;
+       esac
 
        [ "$system" = "$fname" ] \
                && systxt="\"$system\"" \
@@ -304,8 +439,12 @@ for f in $sys; do
 
        sys_target="$target/$fname"
        sys_root="$sys_target"
-       if [ "$DRYRUN" -eq 0 ]; then
-               mkdir -p "$sys_target" >/dev/null 2>&1
+       if [ "$DRYRUN" -eq 0 -a ! -e "$sys_target" ]; then
+               if [ $generations -gt 0 ]; then
+                       CreateSubvolume "$sys_target"
+               else
+                       mkdir -p "$sys_target"
+               fi
                if [ $? -ne 0 ]; then
                        echo "Can't create \"$sys_target\"!? \"$system\" skipped!"
                        echo; continue
@@ -331,16 +470,7 @@ for f in $sys; do
                        echo; continue
                fi
 
-               # Search directory of last generation, if any
-               last=$(ls -1d "$sys_target"/[0-9]* 2>/dev/null | sort -r | head -n1)
-               if [ -n "$last" ]; then
-                       if [ ! -d "$last" ]; then
-                               echo "Last snapshot \"$last\" seems not to be a directory!? \"$system\" skipped!"
-                               echo; continue
-                       fi
-               fi
-               sys_target="$sys_target/$(date +%Y%m%d-%H%M%S)"
-               snapshot="$sys_target"
+               Initialize_Last_SysTarget_Snapshot "$sys_target" || continue
 
                if [ -n "$last" -a ! -e "$last/.stamp" ]; then
                        # Old backup directory without "stamp file", continue
@@ -361,7 +491,7 @@ for f in $sys; do
                                fi
                                echo "Created new snapshot in \"$snapshot\"."
                        else
-                               echo " *** Trial run, not creating new snapshot in \"$sys_target\"!"
+                               echo " *** Trial run, not creating new snapshot in \"$snapshot\"!"
                        fi
                else
                        # No old backup found, create new subvolume